#include "Triangle.h"
#include <cmath>

void Triangle::calc_sides()
{
	sides[0] = dots[0].calc_distance(dots[1]);
	sides[1] = dots[1].calc_distance(dots[2]);
	sides[2] = dots[2].calc_distance(dots[0]);
	is_incorrect = (sides[0] > sides[1] + sides[2]) || (sides[2] > sides[1] + sides[0]) || (sides[1] > sides[2] + sides[0]);



}


Triangle::Triangle()
{
}

double Triangle::calc_area()
{
	double p = sides[0] + sides[1] + sides[2];
	p /= 2;

	return sqrt(p*(p-sides[0])*(p-sides[1])*(p-sides[2]));
}

double Triangle::calc_perimeter()
{
	return sides[0]+sides[1]+sides[2];
}

void Triangle::name()
{
	cout << "Triangle" << endl;
}
